<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div class="wrapper-content">
    <div class="row mx-0 px-0 mb-4">
      <div class="col-12 col-md-5">
        <form class="d-flex">
          <div class="custom-file mr-4 mb-4">
            <input
              type="file"
              class="custom-file-input form-group"
              id="customFile"
              ref="customFile"
              @change="handleFileUpload"
            />
            <label class="custom-file-label" for="customFile">Chọn file...</label>
            <span v-if="!file" style="color: red">
              *
              <span>Bạn chưa chọn file nào</span>
            </span>
          </div>
          <div>
            <button
              class="btn btn-primary"
              id="btn-submit"
              :disabled="isActive"
              @click.prevent="submitFile"
            >Chuyển đổi</button>
          </div>
        </form>
      </div>
    </div>
    <div class="dataTables_wrapper mx-3">
      <div class="table-responsive nt-scroll-primary">
        <table
          class="table table-bordered table-hover s--table s--table-deal-list nt-table-list nt-table-list-all"
        >
          <thead>
            <tr>
              <th style="width: 5%;" class="text-center">STT</th>
              <th style="width: 20%;">Tên</th>
              <th style="width: 15%;" class="text-center">Trạng thái</th>
              <th style="width: 15%;" class="text-center">Trạng thái kiểm tra</th>
              <th style="width: 45%;">Hành động</th>
            </tr>
          </thead>
          <tbody v-if="tableInfo.length > 0">
            <tr v-for="(item, index) in tableInfo" :key="index">
              <td class="text-center">{{ item.id }}</td>
              <td>
                <span>{{ item.name }}</span>
              </td>
              <td>
                <div v-if="item.status === 2">
                  <div
                    class="bg-primary rounded text-white d-flex align-items-center justify-content-center"
                    style="width: 100px; height: 30px"
                  >
                    <span>Đã tải</span>
                  </div>
                </div>
                <div v-if="item.status === 1">
                  <div
                    class="bg-warning rounded text-white d-flex align-items-center justify-content-center"
                    style="width: 100px; height: 30px"
                  >
                    <span>Chưa tải</span>
                  </div>
                </div>
              </td>
              <td>
                <div v-if="item.is_check == 1">
                  <span class="label label-success">{{ item.total_success }}</span> /
                  <span class="label label-info">{{ item.total_all }}</span>
                </div>
              </td>
              <td>
                <a
                  href="javascript:void();"
                  class="btn btn-primary mr-2"
                  @click.prevent="downloadFileConvert(item.id, item.name)"
                >Tải xuống</a>
                <button
                  class="btn btn-warning mr-2"
                  :id="'btnCheck' + item.id"
                  @click.prevent="checkFileConvert(item.id)"
                >Kiểm tra</button>
                <button
                  v-if="(item.is_check == 1 && item.total_success > 0)"
                  class="btn btn-danger mr-2"
                  :id="'btn-import-' + item.id"
                  @click.prevent="importFile(item.id, item.type, item.key)"
                >Import</button>
                <button
                  v-if="(item.is_check == 1 && item.total_success < item.total_all)"
                  class="btn btn-info mr-2"
                  @click.prevent="downloadFileError(item.id, item.type, item.name, item.key)"
                >Tải file lỗi</button>
                <button
                  v-if="(item.is_check == 1 && item.total_success < item.total_all)"
                  class="btn btn-dark mr-2"
                  data-target="#uploadFileModal"
                  data-toggle="modal"
                >Upload file sửa</button>
              </td>
            </tr>
          </tbody>
          <tbody v-else>
            <tr>
              <td colspan="100" class="text-center" style="padding: 20px 0;">
                <span>Chưa có dữ liệu</span>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <div>
      <div
        class="modal fade"
        id="exampleModal"
        tabindex="-1"
        role="dialog"
        aria-labelledby="exampleModalLabel"
        aria-hidden="true"
      >
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Thông báo</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div
              class="modal-body"
            >File của bạn đang được chuyển đổi. Hệ thống sẽ gửi email cho bạn khi việc chuyển đổi hoàn tất</div>
            <div class="modal-footer">
              <button type="button" class="btn text-white btn-close" data-dismiss="modal">Đóng</button>
            </div>
          </div>
        </div>
      </div>

      <div
        class="modal fade"
        id="uploadFileModal"
        tabindex="-1"
        role="dialog"
        aria-labelledby="exampleModalLabel"
        aria-hidden="true"
      >
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Upload File Fixed</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <input
                type="file"
                name="file"
                id="fileImport"
                ref="fileImport"
                class="form-control"
                @change="handleFileImportFix"
              />
            </div>
            <div class="modal-footer">
              <button type="button" class="btn text-white btn-close" data-dismiss="modal">Đóng</button>
              <button
                type="button"
                class="btn text-white btn-primary"
                id="btnUploadFileFixed"
                @click="btnUploadFileClick()"
              >Upload</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      class="spinner d-none"
      style="width: 100vw; height: 100vh; position: absolute; top: 0; z-index: 999"
    >
      <span
        style="position: absolute; right: 50%; top: 50%; transform: translateY(-50%)"
        class="m-loader m-loader--brand"
      ></span>
    </div>
  </div>
</template>